#include <bits/stdc++.h>
#include "testlib.h"
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
using namespace std;

const int MAXN = 1000;
const int MAXT = 50;

char f[MAXN][MAXN], res[MAXN][MAXN];
int n, m;

int readAns(InStream& in, TResult flag) {
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            res[i][j] = '.';
        }
    }

    string s = in.readToken("[UDSNEW]*");

    if (s.size() > 1000000) {
        quitf(flag, "too long programm");        
    }
    
    int curX = 0, curY = 0, curT = 30;
    bool onDown = false;

    for (auto ch : s) {
        if (ch == 'N') {
            --curX;
        }
        if (ch == 'S') {
            ++curX;
        }
        if (ch == 'W') {
            --curY;
        }
        if (ch == 'E') {
            ++curY;
        }
        if (ch == 'U') {
            onDown = false;
        }
        if (ch == 'D') {
            onDown = true;
        }

        if (!(0 <= curX && curX < n && 0 <= curY && curY < m)) {
            quitf(flag, "the bounds are broken (%d,%d)", curX, curY);
        }
        
        if (onDown) {
            res[curX][curY] = '*';
            ++curT;
            if (curT > 50) {
                quitf(flag, "the temperature is greater than 50");
            }
        } else {
            --curT;
            curT = max(curT, 30);
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (res[i][j] != f[i][j]) {
                if (f[i][j] == '.') {
                    quitf(flag, "(%d,%d) shouldn't be frezered", i, j);
                } else {
                    quitf(flag, "(%d,%d) should be frezered", i, j);
                }
            }
        }
    }

    return s.size();
}

int main(int argc, char * argv[]) {
    //cin.tie(0), ios::sync_with_stdio(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    registerTestlibCmd(argc, argv);

    n = inf.readInt();
    m = inf.readInt();

    for(int i = 0; i < n; i++) {
        string s = inf.readString();
        if (s.size() != m) {
            s = inf.readString();
        }
        for (int j = 0; j < m; j++) {
            f[i][j] = s[j];
            res[i][j] = '.';
        }
    }

//    int juryScore = readAns(ans, _fail);
    int partScore = readAns(ouf, _pe);
    if (partScore <= 15) quitf(_ok, "correct - %d moves", partScore);
    if (partScore <= 17) { cout << 9 << "\n"; quitf(_wa, "correct - %d moves", partScore); }
    if (partScore <= 22) { cout << 8 << "\n"; quitf(_wa, "correct - %d moves", partScore); }
    if (partScore <= 25) { cout << 7 << "\n"; quitf(_wa, "correct - %d moves", partScore); }
    if (partScore <= 30) { cout << 6 << "\n"; quitf(_wa, "correct - %d moves", partScore); }
    if (partScore <= 35) { cout << 5 << "\n"; quitf(_wa, "correct - %d moves", partScore); }
    if (partScore <= 44) { cout << 4 << "\n"; quitf(_wa, "correct - %d moves", partScore); }
    if (partScore <= 49) { cout << 3 << "\n"; quitf(_wa, "correct - %d moves", partScore); }
    if (partScore <= 56) { cout << 2 << "\n"; quitf(_wa, "correct - %d moves", partScore); }
    if (partScore <= 61) { cout << 1 << "\n"; quitf(_wa, "correct - %d moves", partScore); }
    cout << max(0, min(9, int(10 * (1. - partScore / (n * m * 3.0)))))  << "\n";
    quitf(_wa, "correct - %d moves", partScore);
    return 0;
}
