#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cmath>
using namespace std;

const int MAXN = 220000;
int parent[MAXN];
int rnk[MAXN];

void make_set (int v) {
    parent[v] = v;
    rnk[v] = 0;
}

int find_set (int v) {
    if (v == parent[v])
        return v;
    return parent[v] = find_set (parent[v]);
}

void union_sets (int a, int b) {
    a = find_set (a);
    b = find_set (b);
    if (a != b) {
        if (rnk[a] < rnk[b])
            swap (a, b);
        parent[b] = a;
        if (rnk[a] == rnk[b])
            ++rnk[a];
    }
}

int main()
{
    int n, g, m;
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> g >> m;
    for (int i = 1; i <= n; i++) {
        make_set(i);
    }
    for (int i = g; i <= n; i++) {
        bool prev = false;
        for (int j = i; j <= n; j += i) {
            if (prev) {
                union_sets(j - i, j);
            } else {
                prev = true;
            }
        }
    }
    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y;
        int cur_x = find_set(x);
        int cur_y = find_set(y);
        cout << (cur_x == cur_y ? "Yes" : "No") << "\n";
    }

    return 0;
}
