#include <mutex>
#include <chrono>
#include <thread>

using namespace std::chrono_literals;

int if_mode = false;

class Int {
   int x;
public:
   Int(int x = 0) : x(x) {}
   void increase() { 
      ++x;
   }
   void decrease() {
      --x; 
   }
   operator int() {
      if (if_mode) {
	  int y = x;
	  std::this_thread::sleep_for(10ns);
	  return y;
      }
      return x;
   }
};

class Mutex {
    std::mutex m;
public:
    void enter() {
	m.lock();
    }
    void leave() {
	m.unlock();
    }
};

void read(int mode);
void write(int mode);

